'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var core = require('@sewing-kit/core');

const PLUGIN = 'SewingKit.Babel';
function babel({
  config = {}
} = {}) {
  return core.createProjectPlugin(PLUGIN, ({
    tasks: {
      dev,
      build,
      test
    }
  }) => {
    const addBabelHooks = core.addHooks(() => ({
      babelConfig: new core.WaterfallHook()
    }));

    const addBabelConfig = () => config;

    test.hook(({
      hooks
    }) => {
      hooks.configureHooks.hook(addBabelHooks);
      hooks.configure.hook(configure => {
        var _configure$babelConfi;

        (_configure$babelConfi = configure.babelConfig) === null || _configure$babelConfi === void 0 ? void 0 : _configure$babelConfi.hook(addBabelConfig);
      });
    });
    build.hook(({
      hooks
    }) => {
      hooks.configureHooks.hook(addBabelHooks);
      hooks.target.hook(({
        hooks
      }) => {
        hooks.configure.hook(configure => {
          var _configure$babelConfi2;

          (_configure$babelConfi2 = configure.babelConfig) === null || _configure$babelConfi2 === void 0 ? void 0 : _configure$babelConfi2.hook(addBabelConfig);
        });
      });
    });
    dev.hook(({
      hooks
    }) => {
      hooks.configureHooks.hook(addBabelHooks);
      hooks.configure.hook(configure => {
        var _configure$babelConfi3;

        (_configure$babelConfi3 = configure.babelConfig) === null || _configure$babelConfi3 === void 0 ? void 0 : _configure$babelConfi3.hook(addBabelConfig);
      });
    });
  });
}

exports.babel = babel;
